
#include <iostream>
#include <vector>
#include <unistd.h>
#include "thread.h"
using namespace std;

bool Safe = true;
Mutex ScreenMutex;

class CharPrintThread : public Thread
{
    private:
        char c;
        int t;
    protected:
        void RunThread()
        {
            while(1)
            {
                
                if(Safe)
                    ScreenMutex.Lock();
                
                for(int i = 0; i < 10; i++)
                {
                    cout << c;
                    cout.flush();
                    usleep(50000);
                }
                cout << endl;
                cout.flush();
                
                if(Safe)
                    ScreenMutex.Unlock();
                
                usleep(t);
            }
        }
    public:
        CharPrintThread(char C, int T)
        {
            c=C;
            t=T;
        }
};



int main(int argc, char** argv)
{
    if(argc > 1 && (string)argv[1] == "--unsafe")
        Safe = false;
    
    CharPrintThread a('a', 1000000);
    a.Start();
    CharPrintThread b('b', 700000);
    b.Start();

    cin.ignore(1);

    a.Terminate();
    b.Terminate();

    return 0;
}










